#!/bin/ash
# /opt/local/bin/HistoriqueS.sh, version 0.1
# Note -- En français seulement, pour l'instant.
#
# Objectif : Rassembler divers historiques dans
# ------------ un menu facile à consulter.
#
# Requiert : aemenu, awk, date, less, replaceit, rev, split, urxvt.
#
# (c) musher0, 10 mars 2019. Rév. : aucune encore.
# Licence « musher0 » --
# Je cède gratuitement le droit d'utiliser ce script à quiconque
# il peut rendre service. # Tous autres droits réservés.
#                                      ======================
# Si vous souhaitez diffuser ce script ou l'adapter à vos besoins,
# s.v.p. me contacter avant par MP sur le forum PuppyLinux afin
# de me présenter votre projet, puis que nous en discutions.
#
# Encore à faire --
# -- incorporer d'autres terminaisons de langages informatiques
#        dans la section « scripts »;
# -- semblablement pour la section « textes »;
# -- créer des sections audio et vidéo.
####################################################
killall -q aemenu
LC_ALL=C
ReP=/root/.local/share
cd $ReP

# Ramasser
awk -F"\"" '$0 ~ /\:\// && $0 !~ /freedesktop|\.cdr/ {print $2}' recently-used.xbel > liste

# Élaguer
replaceit --input=liste "file:///" "/"
replaceit --input=liste T%C3%A9l%C3%A9chargements Downloads

## Trier # généralement
rev liste | sort | rev > tri

FignolMenu () {
echo "menu $Menu
     cmd \"~~~~~\" \" \"" > $Menu
     cat Parties >> $Menu
echo -e "\tcmd \"~~~~~\" \" \"
end\n"  >> $Menu; }

CreeMenu () {
Menu=""
Menu="$Source.menu"
>$Menu
while read line;do
     if [ -f $line ];then
          P="`echo "$line" | awk -F"\/" '{ print $NF}'`"
          echo "cmd $P \"rox $line\"" >> $Menu
     fi
done < $Source

Combien="`wc -l < $Menu`"
if [  "$Combien" -ge "25" ];then # On coupe à 25 lignes.
     split -l 25 -d --numeric-suffixes=1 $Menu $Menu-
     ls -1 --file-type $Menu-* > liste
     > Parties
     n=1
     while read file; do
          echo "menu $Menu-$n
     cmd \"~~~~~\" \" \"" >> Parties
               cat $file >> Parties
          echo -e "\tcmd \"~~~~~\" \" \"
end\n"  >> Parties
          n="`expr $n + 1`"
     done < liste
else
          cat $Menu > Parties
fi ;}

# images
awk '$0 ~ /\.bmp|\.jpg|\.jpeg|\.png|\.tiff|\.xpm/' tri | sort -u > images

# images ordinaires
Source="";Source=ordinaires
awk '$0 !~ /osees/' images | sort -u > $Source
CreeMenu
FignolMenu

# scripts
Source="";Source=scripts
awk '$0 ~ /\.sh|\.bas|\.h|.pas/' tri | sort -u > $Source
CreeMenu
replaceit --input=Parties rox vis
FignolMenu

# textes
Source="";Source=textes
awk '$0 ~ /\.txt|\.doc|\.docxj|\.odt|\.rtf|\.htm|.html/' tri | sort -u > $Source
CreeMenu
replaceit --input=Parties rox vis
FignolMenu

# On rassemble le tout
LC_ALL=""
echo -e "cmd \"   HistoriqueS\" \" \"
menu \"  Date et heure\"
     cmd \"~~~~~\" \" \"
     cmd \"`date '+%a. %d %b %Y, %R'`\" \"\"
     cmd \"~~~~~\" \" \"
end
cmd \"~~~~~~~~~\" \" \"" > total
LC_ALL=C
cat *.menu >> total
echo "cmd \"~~~~~~~~~\" \" \"" >> total

echo "menu Mtpaint
     cmd \"~~~~~\" \" \"" >> total
awk '$1 ~ /file/ { print $3 }' /root/.mtpaint > /root/mtpaint.lst
while read file;do
     P=""
     if [ -f $file ];then
          P="`echo "$file" | awk -F"\/" '{ print $NF}'`"
          P="${P%.*}"
          echo "cmd $P \"rox $file\"" >> total
     fi
done < /root/mtpaint.lst
echo "cmd \"~~~~~\" \" \"
end" >> total

# On ajoute d'autres historiques.
echo "menu Système
     cmd \"~~~~~\" \" \"" >> total
Q=""
for Q in bash_history boot_history lesshst sqlite_history;do
     echo "cmd $Q /opt/local/bin/$Q.sh" >> total
done
echo "cmd \"~~~~~\" \" \"
end
menu Autres
     cmd \"~~~~~\" \" \"
     cmd \"La plupart des navigateurs et\" \" \"
     cmd \"applis sérieuses ont une entrée\" \" \"
     cmd \"ou un sous-menu d'historique.\" \" \"
     cmd \"Consultez-le ?\" \" \"
     cmd \"~~~~~\" \" \"
end
cmd \"~~~~~~~~~\" \" \"
cmd \"     ~~~~~~~~~\" \" \""  >> total

RPLCT="replaceit --input=total"
$RPLCT "ordinaires.menu" Images
$RPLCT "scripts.menu" Scripts
$RPLCT "textes.menu" Textes

# Nettoyage
rm -f *.menu*
for i in Parties liste textes images scripts tri ordinaires osees;do
     rm -f $i
done
rm -f /root/mtpaint.lst
LC_ALL=""

# Shoot!
aemenu -rc total
